/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WebhookEventMedia type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WebhookEventMedia{}

// WebhookEventMedia struct for WebhookEventMedia
type WebhookEventMedia struct {
	Url string `json:"url"`
	MimeType string `json:"mime_type"`
	Status string `json:"status"`
}

// NewWebhookEventMedia instantiates a new WebhookEventMedia object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWebhookEventMedia(url string, mimeType string, status string) *WebhookEventMedia {
	this := WebhookEventMedia{}
	this.Url = url
	this.MimeType = mimeType
	this.Status = status
	return &this
}

// NewWebhookEventMediaWithDefaults instantiates a new WebhookEventMedia object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWebhookEventMediaWithDefaults() *WebhookEventMedia {
	this := WebhookEventMedia{}
	return &this
}

// GetUrl returns the Url field value
func (o *WebhookEventMedia) GetUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Url
}

// GetUrlOk returns a tuple with the Url field value
// and a boolean to check if the value has been set.
func (o *WebhookEventMedia) GetUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Url, true
}

// SetUrl sets field value
func (o *WebhookEventMedia) SetUrl(v string) {
	o.Url = v
}

// GetMimeType returns the MimeType field value
func (o *WebhookEventMedia) GetMimeType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MimeType
}

// GetMimeTypeOk returns a tuple with the MimeType field value
// and a boolean to check if the value has been set.
func (o *WebhookEventMedia) GetMimeTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MimeType, true
}

// SetMimeType sets field value
func (o *WebhookEventMedia) SetMimeType(v string) {
	o.MimeType = v
}

// GetStatus returns the Status field value
func (o *WebhookEventMedia) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *WebhookEventMedia) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *WebhookEventMedia) SetStatus(v string) {
	o.Status = v
}

func (o WebhookEventMedia) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WebhookEventMedia) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["url"] = o.Url
	toSerialize["mime_type"] = o.MimeType
	toSerialize["status"] = o.Status
	return toSerialize, nil
}

type NullableWebhookEventMedia struct {
	value *WebhookEventMedia
	isSet bool
}

func (v NullableWebhookEventMedia) Get() *WebhookEventMedia {
	return v.value
}

func (v *NullableWebhookEventMedia) Set(val *WebhookEventMedia) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookEventMedia) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookEventMedia) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookEventMedia(val *WebhookEventMedia) *NullableWebhookEventMedia {
	return &NullableWebhookEventMedia{value: val, isSet: true}
}

func (v NullableWebhookEventMedia) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookEventMedia) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


